<!DOCTYPE html>
<head lang="en">
  <title>SinCos</title>
  <meta charset="utf-8"/>
  <style>
	p {font-family: monospace;}
	
	input[type=range] {
		-webkit-appearance: none;
		background: transparent;
	}
	
	input[type=range]::-webkit-slider-thumb {
		-webkit-appearance: none;
		border: 1px solid #111;
		background: #fff;
		transition-duration: .2s;
		transition-property: background, outline;
		height: 13px;
		width: 13px;
	}
	
	input[type=range]:focus::-webkit-slider-thumb {
		background: #ffb744;
	}
	
	input[type=range]::-webkit-slider-runnable-track {
		-webkit-appearance: none;
		border: 1px solid #111;
		background: #fff;
		height: 15px;
		width: 100%;
	}
  </style>
</head>
<body>
  <canvas id="canvas" width=720 height=720></canvas>
  <p id="sigma_para"></p>
  <input id="sigma_rate" type="range" min="-200" max="200" value="100"></input>
  <script>
    ///////
	
    const tau = 6.2831853; // Closer approximation of PI * 2 also known as TAU

    const can = document.getElementById('canvas');
    const ctx = can.getContext('2d');

    const sigma_para = document.getElementById('sigma_para');
	const sigma_rate = document.getElementById('sigma_rate');
	
    const width = can.width; // Read canvas width
    const height = can.height; // Read canvas height

    function createCircularDrawing(outcomes, isOpen) {
      // Takes an array of points and draw them
      ctx.beginPath();
      for (var index in outcomes) {
        ctx.lineTo(outcomes[index][0] + width / 2, -outcomes[index][1] + height / 2);
      }
      if(!isOpen) {
        ctx.closePath();
      } else {}
      ctx.stroke();
    }

    function clearContext() {
      ctx.clearRect(0, 0, width, height);
    }

    function createSinFigures(step, sigma, radius, centrum_coord) {
      var coords = [];
      var coord = [0, 0];
      for (var radians = 0; radians < tau; radians += step) {
        coords.push([Math.sin(radians) * Math.sin(radians * sigma) * Math.cos(radians * 5) * radius + centrum_coord[0], Math.cos(radians) * Math.cos(radians * sigma) * Math.sin(radians * 5) * radius + centrum_coord[1]]);
      }
      return coords;
    }

	function main() {
        clearContext();
        createCircularDrawing(createSinFigures(0.001, sigma, height / 2, [0, 0]), false);
		slope += rate / 1000;
		rate += (rgho - rate) / 10;
		rgho = sigma_rate.value / 100;
        sigma_para.innerText = sigma;
        sigma = (Math.sin((slope - 0.5) * tau) + slope * tau) / tau;
		requestAnimationFrame(main);
      }

    ///////

    var sigma = 0;
    var slope = 0;
	var rate = 1.0;
	var rgho = 0.0;
	requestAnimationFrame(main);

    ///////
  </script>
</body>
